/**********************************************************************
    dattypes.h
  
    RealNumbers  1.0
    Copyright (C) 1997  Antonio Larrosa Jimenez

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************/
#ifndef _DATTYPES_H 
#define _DATTYPES_H

  #define MAX(a,b) (word)((a<b)?(b):(a))
  #define MIN(a,b) (word)((a<b)?(a):(b))

  #define MAXl(a,b) (ulong)((a<b)?(b):(a))
  #define MINl(a,b) (ulong)((a<b)?(a):(b))

  enum sign {positivo,negativo};

  typedef unsigned char byte;
  typedef unsigned short word;
  typedef unsigned long ulong;
  typedef unsigned long dword;
  typedef unsigned long FuncP;
//  typedef char bool;

  #define SI 1
  #define NO 0
  #define QUIZAS 2
  #define OK 1
  #define ERROR 0

#endif
