#ifdef NUMERO
#define T Numero
#define CLASE_DE_PRUEBA "Numero"
#include "numero.h"
#endif
#ifdef NUMEROE
#define T NumeroE 
#define CLASE_DE_PRUEBA "NumeroE"
#include "numeroe.h"
#endif

#include <stdio.h>
#include <stdlib.h>

ulong MAX_CIFRAS_DEC=30;
Cifra BASE_N=10;

T Calcula_e(long precision)
{

/* Esta funcion calcula e usando que  
          oo
         ____      
        \        1 
 e =      >     ---
        /____    k!   
        k = 0    
*/

T e;++e;++e;  // En realidad no empieza por k = 0 ...
Numero k;++k;++k;  // ... sino por k = 2
T e2;
T ebak;
T e2bak;
T tmp;
Numero fact;++fact;
T Tfact;
T Uno;++Uno;
ulong oldMaxCifrasDec=MAX_CIFRAS_DEC;
MAX_CIFRAS_DEC=precision;
long i=precision;
while (i>0)
    {
#ifdef DEBUG
    cout << "(" << precision-i << ") " << e << endl;
#endif
    fact=fact*k;  // Para hacer el factorial mas rapido se usa este truco
    Tfact=fact;
    tmp=Uno/Tfact;
#ifdef DEBUG    
    cout << "1/k! :" << tmp << endl;
#endif
    e2=e+tmp;     
    ebak=e;
    e2bak=e2;
    ebak.Precision(precision);
    e2bak.Precision(precision);
    if (e2bak==ebak)
        i=0; // Ya ha convergido bastante ...
       else 
        e=e2; 
    k++;
//    i--;
    };
MAX_CIFRAS_DEC=oldMaxCifrasDec;
return e;
};




int main(int argc,char **argv)
{
char s[200];
printf("Este programa calcula el numero e usando la clase ""%s"".\n",CLASE_DE_PRUEBA);
printf("Base %d\n",BASE_N);
if (argc>1) 
	{
	strcpy(s,argv[1]);
	}
   else
	{
	printf(" Con cuantas cifras decimales quiere calcular e ? ");
	gets(s);
	};
if (s[0]==0) return 0;
long prec=atol(s);

if (argc>2) 
	{
	strcpy(s,argv[2]);
	}
   else
	{
	printf(" En que base ? ");
	gets(s);
	};
if (s[0]==0) strcpy(s,"10");
BASE_N=atol(s);
if ((BASE_N<2)||(BASE_N>36)) BASE_N=10;

printf("Calculando e con %ld cifras decimales en base %d\n",prec,BASE_N);

T e;
e=Calcula_e(prec);
e.Precision(prec);
cout << e << endl;
return 0;
};

