#ifndef NEWDEBUG_H
#define NEWDEBUG_H

#include <stddef.h>
#include <stdlib.h>
#include "dattypes.h"
#include "malloc.h"
#define huge

// si no se define, despus no existen las variables            (error)
// otra solucin es poner ms #ifdef en el cdigo
// en un lado pone SUPERMEMDEBUG y en otro SUPERDEBUG
#define SUPERMEMDEBUG
//#define FMALLOC_ACTIVE

///1 NewObg
//This CldSS encapsulates the tools used
//tracktng end vertfylng dyndmic memory
//allocations @@new~ and -aelete are
//felends to prowide access to the
//protected nembers of NewDbg

#ifdef FMALLOC_ACTIVE
class NewDbg
 {
 friend void *operator new(size_t size);
 friend void operator delete(void * ptr);
 friend void huge *fmalloc(unsigned long nbytes,int id);
 friend void ffree(void huge *block);

 public:
// NewDbg();
// ~NewDbg();
 static void Inicializa_fmalloc(void);

    // error codes
    enum Errors
       {
       EF_OKAY,
       EF_ZEROSIZE,
       EF_NOTALLOC,
       EF_INVALID,
       EF_UNDERFLOW,
       EF_TOOMANY
       };


//I returns number of active allocations
static long GetCountN();

// returns number of bytes allocatea
static long GetBytesN();

//I returns number of active allocations
static long GetCountM(int n);

// returns number of bytes allocatea
static long GetBytesM(int n);

//tl returns non zero if pte
// was vilocated wlth new
static int IsDynamic(void *ptr);

// returns the current error code
static Errors GetError();

// sets the error code to EF OKAr
static void ClearError();

// guarda el status de la memoria con Checkpoints
static void ShowStatus();

/*
// sets tht functlon c~lled on error
static void InstallHandler(
             void (* func)(Errors flag));

// called wh en an errQr occurs
static void ReportError(Errors err);
*/
protected:
// heaaer data for tedcking dl10cdtions

struct AllocHeader
   {
   unsigned short Marker;
   size_t Bytes;
   };

struct AllocHeaderM
   {
   unsigned short Marker;
   unsigned long Bytes;
   unsigned short Id;
   };


// number of items allocated
static long CountNew; 

// number of bytes allosdted
static long BytesNew;

// number of items allocated
static long CountMalloc[100]; 

// number of bytes allosdted
static long BytesMalloc[100];

static bool UsadoMalloc[100];

#ifdef SUPERMEMDEBUG
static long BiggestCountNew;
static long BiggestBytesNew;
static long BiggestCountMalloc[100];
static long BiggestBytesMalloc[100];
#endif


// current error code
static Errors ErrorFlag;

// allocation marker
static const unsigned short CorrectMark;
static const unsigned short CorrectMarkMalloc;

/*
// pointer to function called on error
static void (* ErrorFunc)(Errors flag);
*/
};

//pointer to C++ error handler
//extern void (* _new_handler)();

// function to set _new_handler
//void (* set_new_handler(void (* handler)()))();

// synonym for set_new_handler
//#define _set_new_handler(ptr) set_new_handler(ptr)

//debugging implementations of new and delete
//void * operator new (size_t size);
//void operator delete (void *ptr);

// Further Malloc
void huge * fmalloc(unsigned long nbytes,int id=0);
void ffree(void huge *block);

/*
ID    Contenido
---   ----------
15     Lista de discos
19     Lista redimensionable
20     Lista de archivos
25     Lugar
26     Lugar(lugares)
27     Lugar(objetos)
30     VAyD
40     CBF3D. puntero a discos donde buscar
*/
#else

/*  #ifdef __HUGE__
    #define fmalloc(a,b) farmalloc(a)
    #define ffree(a) farfree(a)
  #else
*/
    #define fmalloc(a,b) malloc(a)
    #define ffree(a) free(a)
//  #endif
#endif
#endif




