/**********************************************************************
    numfunc.cc  -- Algunas rutinas que son usadas por los numeros
  
    RealNumbers  1.0
    Copyright (C) 1997  Antonio Larrosa Jimenez

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************/
#include "numfunc.h"
#include "numconst.h"

bool Es_numero_en_base(char c,byte base)
{
byte b;
if ((c<'0')||(c>'Z')) return NO;
if ((c>'9')&&(c<'A')) return NO;
// Ya sabemos que c es un numero o una letra mayuscula
if (c<='9') b=c-'0';
   else b=c-'A';
return (b<base);
};

bool Es_un_numero_correcto(char *s,byte base,char *admite)
{
char *pc=s;
bool ok=SI;
while ((*pc!=0)&&(ok))
    {
    if (!Es_numero_en_base(*pc,base))
        {
        char *p2=admite;
        bool esta=NO;
        while ((*p2!=0)&&(!esta))
            {
            if (*p2==*pc) esta=SI;
            p2++;
            };
        ok=esta;
        };
    pc++;
    };
return ok;
};


